Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree.linked
Class LinkedTreeBuilder

    java.lang.Object
      net.sf.saxon.event.Builder
          net.sf.saxon.tree.linked.LinkedTreeBuilder

All Implemented Interfaces:
  Result, Receiver

    public class LinkedTreeBuilder

extends Builder

The LinkedTreeBuilder class is responsible for taking a stream of Receiver events and constructing a Document tree using the linked tree implementation.

Author:
  Michael H. Kay

Field Summary

Fields inherited from class net.sf.saxon.event.Builder
`baseURI, config, currentRoot, JDOM_TREE, JDOM2_TREE, lineNumbering, LINKED_TREE, namePool, open, pipe, STANDARD_TREE, started, systemId, timing, TINY_TREE, TINY_TREE_CONDENSED, UNSPECIFIED_TREE_MODEL`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`LinkedTreeBuilder(PipelineConfiguration pipe)` Create a Builder and initialise variables

Method Summary
`void` | `attribute(NodeName attName, SimpleType typeCode, CharSequence value, int locationId, int properties)` Notify an attribute.
`void` | `characters(CharSequence chars, int locationId, int properties)` Notify a text node.
`void` | `close()` Close the stream of Receiver events
`void` | `comment(CharSequence chars, int locationId, int properties)` Notify a comment
`void` | `endDocument()` Notify the end of the document
`void` | `endElement()` Notify the end of an element
`BuilderMonitor` | `getBuilderMonitor()` Get a builder monitor for this builder.
`NodeImpl` | `getCurrentLeafNode()` Get the current text, comment, or processing instruction node
`net.sf.saxon.tree.linked.ParentNodeImpl` | `getCurrentParentNode()` Get the current document or element node
`NodeInfo` | `getCurrentRoot()` Get the current root node.
`void` | `graftElement(ElementImpl element)` graftElement() allows an element node to be transferred from one tree to another.
`void` | `namespace(NamespaceBinding namespaceBinding, int properties)` Notify a namespace.
`void` | `open()` Open the stream of Receiver events
`void` | `processingInstruction(String name, CharSequence remainder, int locationId, int properties)` Notify a processing instruction
`void` | `reset()` Reset the builder to its initial state.
`void` | `setAllocateSequenceNumbers(boolean allocate)` Set whether the builder should allocate sequence numbers to elements as they are added to the tree.
`void` | `setNodeFactory(NodeFactory factory)` Set the Node Factory to use.
`void` | `setUnparsedEntity(String name, String uri, String publicId)` Set an unparsed entity URI for the document
`void` | `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` | `startDocument(int properties)` Start of a document node.
`void` | `startElement(NodeName nameCode, SchemaType typeCode, int locationId, int properties)` Notify the start of an element

Methods inherited from class net.sf.saxon.event.Builder
`getBaseURI, getConfiguration, getPipelineConfiguration, getSystemId, isTiming, setBaseURI, setLineNumbering, setPipelineConfiguration, setSystemId, setTiming, usesTypeAnnotations`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### LinkedTreeBuilder

    public LinkedTreeBuilder(PipelineConfiguration pipe)

  Create a Builder and initialise variables

  Parameters:
    `pipe` - the pipeline configuration

Method Detail

### getCurrentRoot

    public NodeInfo getCurrentRoot()

  Get the current root node. This will normally be a document node, but if the root of the tree is an element node, it can be an element.

  Overrides:
    `getCurrentRoot` in class `Builder`
  Returns:
    the root of the tree that is currently being built, or that has been most recently built using this builder

### reset

    public void reset()

  Description copied from class: `Builder`
  Reset the builder to its initial state. The most important effect of calling this method (implemented in subclasses) is to release any links to the constructed document tree, allowing the memory occupied by the tree to released by the garbage collector even if the Builder is still in memory. This can happen because the Builder is referenced from a parser in the Configuration's parser pool.

  Overrides:
    `reset` in class `Builder`

### setAllocateSequenceNumbers

    public void setAllocateSequenceNumbers(boolean allocate)

  Set whether the builder should allocate sequence numbers to elements as they are added to the tree. This is normally done, because it provides a quick way of comparing document order. But nodes added using XQuery update are not sequence-numbered.

  Parameters:
    `allocate` - true if sequence numbers are to be allocated

### setNodeFactory

    public void setNodeFactory(NodeFactory factory)

  Set the Node Factory to use. If none is specified, the Builder uses its own.

  Parameters:
    `factory` - the node factory to be used. This allows custom objects to be used to represent the elements in the tree.

### open

    public void open()

  Open the stream of Receiver events

  Specified by:
    `open` in interface `Receiver`
  Overrides:
    `open` in class `Builder`

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Start of a document node. This event is ignored: we simply add the contained elements to the current document

  Parameters:
    `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException` - if an error occurs

### endDocument

    public void endDocument()
                     throws XPathException

  Notify the end of the document

  Throws:
    `XPathException` - if an error occurs

### close

    public void close()
               throws XPathException

  Close the stream of Receiver events

  Specified by:
    `close` in interface `Receiver`
  Overrides:
    `close` in class `Builder`
  Throws:
    `XPathException` - if an error occurs

### startElement

    public void startElement(NodeName nameCode,
                             SchemaType typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Notify the start of an element

  Parameters:
    `nameCode` - the name of the element.
    `typeCode` - the type annotation of the element.
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - bit-significant properties of the element node. If there are no revelant properties, zero is supplied. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException` - if an error occurs

### namespace

    public void namespace(NamespaceBinding namespaceBinding,
                          int properties)

  Description copied from interface: `Receiver`
  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element. The events represent namespace declarations and undeclarations rather than in-scope namespace nodes: an undeclaration is represented by a namespace code of zero. If the sequence of namespace events contains two A namespace must not conflict with any namespaces already used for element or attribute names.

  Parameters:
    `namespaceBinding` - contains the namespace prefix and namespace URI
    `properties` - The most important property is REJECT_DUPLICATES. If this property is set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error:

### attribute

    public void attribute(NodeName attName,
                          SimpleType typeCode,
                          CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Description copied from interface: `Receiver`
  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Parameters:
    `attName` - The name of the attribute
    `typeCode` - The type of the attribute, as held in the name pool. The additional bit NodeInfo.IS_DTD_TYPE may be set to indicate a DTD-derived type.
    `value` - the string value of the attribute
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this attribute
  NO_SPECIAL_CHARACTERS
    Attribute value contains no special characters
  Throws:
    `XPathException` - if an error occurs

### startContent

    public void startContent()
                      throws XPathException

  Description copied from interface: `Receiver`
  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

  Throws:
    `XPathException` - if an error occurs

### endElement

    public void endElement()
                    throws XPathException

  Notify the end of an element

  Throws:
    `XPathException` - if an error occurs

### characters

    public void characters(CharSequence chars,
                           int locationId,
                           int properties)
                    throws XPathException

  Notify a text node. Adjacent text nodes must have already been merged

  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  Throws:
    `XPathException` - if an error occurs

### processingInstruction

    public void processingInstruction(String name,
                                      CharSequence remainder,
                                      int locationId,
                                      int properties)

  Notify a processing instruction

  Parameters:
    `name` - The PI name. This must be a legal name (it will not be checked).
    `remainder` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI.

### comment

    public void comment(CharSequence chars,
                        int locationId,
                        int properties)
                 throws XPathException

  Notify a comment

  Parameters:
    `chars` - The content of the comment
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment.
  Throws:
    `XPathException` - if an error occurs

### getCurrentParentNode

    public net.sf.saxon.tree.linked.ParentNodeImpl getCurrentParentNode()

  Get the current document or element node

  Returns:
    the most recently started document or element node (to which children are currently being added) In the case of elements, this is only available after startContent() has been called

### getCurrentLeafNode

    public NodeImpl getCurrentLeafNode()

  Get the current text, comment, or processing instruction node

  Returns:
    if any text, comment, or processing instruction nodes have been added to the current parent node, then return that text, comment, or PI; otherwise return null

### graftElement

    public void graftElement(ElementImpl element)
                      throws XPathException

  graftElement() allows an element node to be transferred from one tree to another. This is a dangerous internal interface which is used only to contruct a stylesheet tree from a stylesheet using the "literal result element as stylesheet" syntax. The supplied element is grafted onto the current element as its only child.

  Parameters:
    `element` - the element to be grafted in as a new child.
  Throws:
    `XPathException`

### setUnparsedEntity

    public void setUnparsedEntity(String name,
                                  String uri,
                                  String publicId)

  Set an unparsed entity URI for the document

  Parameters:
    `name` - The name of the unparsed entity
    `uri` - The system identifier of the unparsed entity
    `publicId` - The public identifier of the unparsed entity

### getBuilderMonitor

    public BuilderMonitor getBuilderMonitor()

  Get a builder monitor for this builder. This must be called immediately after opening the builder, and all events to the builder must thenceforth be sent via the BuilderMonitor.

  Overrides:
    `getBuilderMonitor` in class `Builder`
  Returns:
    a new BuilderMonitor appropriate to this kind of Builder; or null if the Builder does not provide this service

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.